/*  ,           , ..       ,   */

SET TERM !! ;

CREATE OR ALTER TRIGGER TR_FACIALFINCAPTION_BU FOR FACIALFINCAPTION
ACTIVE BEFORE UPDATE POSITION 0
as
declare variable DocNumber integer;
declare variable DetCount integer;
begin
  if (new.credit is null)then new.credit=0;
  if (new.ArhiveDoc is null) then new.ArhiveDoc=0;
  if (new.PayTypeCls is null) then new.PayTypeCls=0;
  if (new.BuhPaymentCls is null) then new.BuhPaymentCls=0;
  if (new.BuhOperationCLS is null) then
    execute procedure GetIntConst(60, 15) returning_values new.BuhOperationCLS;
  if (new.ClsType is null) then new.ClsType = 0;
  if (new.DestClsType is null) then new.DestClsType = new.ClsType;
  if (new.SourceFacialAcc_CLS is null) then new.SourceFacialAcc_CLS=0;
  if (new.DestFacialAcc_CLS is null) then new.DestFacialAcc_CLS=0;
  if (new.OperationDirection is null) then new.OperationDirection = 0;
  if (new.DocType is null) then new.DocType = 0;
  if (new.OperationDirection <> old.OperationDirection) then
  begin
    if (new.OperationDirection = 0) then
    begin
      new.SourceType = 1;
      new.DestType = 1;
    end
    else
      if (new.OperationDirection = 1) then
      begin
        new.SourceType = 1;
        new.DestType = -1;
      end
      else
        if (new.OperationDirection = 2) then
        begin
          new.SourceType = -1;
          new.DestType = 1;
        end
        else
        begin
          new.SourceType = -1;
          new.DestType = -1;
        end
  end
  if (new.DepartmentCls is null) then
  begin
    execute procedure GetIntConst(30, 20) returning_values DocNumber; 
    if (DocNumber is null) then new.DepartmentCls=0;
    else new.DepartmentCls=DocNumber;
  end
  /*     */
  if (new.BudgetRef <> old.BudgetRef) then
    if ( not((new.BudgetRef is null) and (old.BudgetRef is null)) ) then
    begin
      select count(ID) from FacialFinDetail where RecordIndex = old.ID
      into :DetCount;
      if (DetCount > 0) then exception Ex_CantModufyBudget;
    end
  /*        */
  if ((new.AcceptDate is not null) and (new.Reject_Cls is not null)) then
    exception EX_DOCNOTACCEPTREJECT;
end
!!

commit work!!

SET TERM ; !!

